using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
CategoryBuilder.Create("The JohnnyVerse", "Example", ModAPI.LoadSprite("thumbnail.png"));

//The JohnnyVerse
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Amber Heard", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Also known as Amber Turd", //new item description
        CategoryOverride = ModAPI.FindCategory("The JohnnyVerse"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnail.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Amber Heard.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, null, null, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
            person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
            person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);


ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Johnny Depp (Blue Suit)", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Loves Mega Pints!", //new item description
        CategoryOverride = ModAPI.FindCategory("The JohnnyVerse"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnail2.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("JohnnyDepp.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, null, null, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
            person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
            person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

{
                     
                        var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Helmet");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0.0f, 0.0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("JohnnyDeppTail.png");
                        childSprite.sortingLayerName = "Bottom";
                        };
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Cpt Jack Sparrow", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "But you have heard of me!", //new item description
        CategoryOverride = ModAPI.FindCategory("The JohnnyVerse"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnail4.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Cpt.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, null, null, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
            person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
            person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

{
                     
                        var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Helmet");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0.0f, 0.0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Cpthat.png");
                        childSprite.sortingLayerName = "Bottom";
                        };
        }
    }
);
        }
    }
}